routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/
Route::prefix('admin')->name('admin.')->group(function () {
    Route::get('/', [\App\Http\Controllers\Admin\AdminArticleController::class, 'index'])->name('home');
    Route::resource('articles', \App\Http\Controllers\Admin\AdminArticleController::class)->except('index', 'create', 'store', 'show');
    Route::resource('comments', \App\Http\Controllers\Admin\AdminCommentController::class)->except('create', 'store', 'show');
});

Route::get('/', [\App\Http\Controllers\ArticleController::class, 'index']);
Route::get('/users/{user}', [\App\Http\Controllers\UserController::class, 'show'])->name('profile');
Route::resource('articles', \App\Http\Controllers\ArticleController::class)->except('index');
Route::post('categoryFilter', [\App\Http\Controllers\ArticleController::class, 'filter'])->name('filter');
Route::patch('articleRate', [\App\Http\Controllers\ArticleController::class, 'rate'])->name('rate');
Route::resource('comments', \App\Http\Controllers\CommentsController::class)->except('index', 'create', 'show');
Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Article.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use PharIo\Manifest\Author;

class Article extends Model
{
    use HasFactory;

    protected $fillable = [
        'title',
        'body',
        'user_id',
        'category_id',
        'like',
        'actuality',
        'quality',
        'publish_time'
    ];

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function comments()
    {
        return $this->hasMany(Comment::class);
    }

    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    public function tags()
    {
        return $this->belongsToMany(Tag::class);
    }
}

app/Http/Controllers/ArticleController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ArticleStoreRequest;
use App\Http\Requests\RateStoreRequest;
use App\Models\Article;
use App\Models\Category;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;

class ArticleController extends Controller
{
    public function index()
    {
        $categories = Category::all();
        $time = time();
        $articles = Article::whereRaw("publish_time < $time")->paginate(10);
        return view('index', compact('articles', 'time', 'categories'));
    }

    public function create()
    {
        $categories = Category::all();
        $user = Auth::id();
        return view('articles.create', compact('user', 'categories'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(ArticleStoreRequest $request)
    {
        $validated = $request->validated();
        $article = new Article($validated);
        $article->save();
        return redirect('/')->with('status', 'Статья отправлена к администрации!');
    }

    public function show(Article $article)
    {
        $timePub = date('Y/m/d H:i:s', $article->publish_time);
        $user = Auth::user();
        $author = $article->user();
        return view('articles.show', compact('article', 'user', 'timePub', 'author'));
    }

    public function edit(Article $article)
    {
        $user = Auth::id();
        $categories = Category::all();
        return view('articles.edit', compact('article', 'user', 'categories'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(ArticleStoreRequest $request, Article $article)
    {
        $user = Auth::user();
        $validated = $request->validated();
        $article->update($validated);
        return redirect()->route('profile', compact('user'))->with('status', 'Статья обновлена');
    }

    public function destroy(Article $article)
    {
        $user = Auth::user();
        $article->delete();
        return redirect()->route('profile', compact('user'))->with('status', 'Статья удалена');
    }

    public function filter(Category $category)
    {
        $categories = Category::all();
        $time = time();
        $articles = Article::whereRaw("publish_time > $time", "category_id == $category->id");
        $articles = $articles::whereRaw()->paginate(10);
        return view('index', compact('articles', 'time', 'categories'));
    }

    public function rate(RateStoreRequest $request, Article $article)
    {
        $validated = $request->validated();
        $like_scale = $article->likes_scale + $validated['like'];
        $quality_scale = $article->quality_scale + $validated['quality'];
        $actuality_scale = $article->actuality_scale + $validated['actuality'];
        $article->likes_scale = $like_scale;
        $article->actuality_scale = $actuality_scale;
        $article->quality_scale = $quality_scale;
        $article->title = $validated['title'];
        $article->body = $validated['body'];
        $article->category_id = $validated['category_id'];
        $article->user_id = $validated['user_id'];
        $article->update();
        return redirect()->back()->with('status', 'Благодарим за оценку!');
    }
}

resources/views/admin/articles/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <h1>Редактирование статьи</h1>
        <div style="text-align: center">
            <form method="post" action="{{route('admin.articles.update', compact('article'))}}">
                @csrf
                @method('PUT')
                <div>
                    <p>Заголовок</p>
                    <textarea name="title" id="title" required>
                        {{$article->title}}
                    </textarea>
                    @error('title')
                    <div class="alert alert-danger">Заголовок обязателен и должен быть не менее 5 и не более 30 символов!</div>
                    @enderror
                </div>
                <div>
                    <p>Содержание</p>
                    <textarea name="body" id="body" required>{{$article->body}}</textarea>
                    @error('publish_time')
                    <div class="alert alert-danger">Содержание обязательно и должно быть не менее 100 и не более 500 символов!</div>
                    @enderror
                </div>
                <div>
                    <p>Выберите категорию</p>
                    <select name="category_id" id="category_id">
                        @foreach($categories as $category)
                            <option name="category_id" value="{{$category->id}}">{{$category->title}}</option>
                        @endforeach
                    </select>
                </div>
                <div>
                    <p>Введите дату публикации</p>
                    <input type="datetime-local" id="publish_time" name="publish_time">
                </div>
                <input type="hidden" name="user_id" value="{{$article->user->id}}">
                <button type="submit">Обновить</button>
            </form>
        </div>
    </div>
@endsection

resources/views/admin/articles/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <h1>Редактирование статей</h1>
        <a class="btn btn-warning" href="{{route('admin.comments.index')}}">Раздел комментариев</a>
        <table>
            <thead>
                <tr>
                    <td>
                        Название статьи
                    </td>
                    <td>
                        Действия
                    </td>
                    <td>
                        Время публикации
                    </td>
                </tr>
            </thead>
            <tbody>
                @foreach($articles as $article)
                    <tr>
                    <td>
                        {{$article->title}}
                    </td>
                    <td>
                        <a class="btn btn-success" href="{{route('admin.articles.edit', compact('article'))}}">
                            Редактировать
                        </a>
                        <form method="post" action="{{route('admin.articles.destroy', compact('article'))}}">
                            @csrf
                            @method('DELETE')
                            <button class="btn btn-danger">Удалить</button>
                        </form>
                    </td>
                    <td>
                        @if($article->publish_time == null)

                        @else
                            {{date('Y/m/d H:i:s', $article->publish_time)}}
                        @endif
                    </td>
                    </tr>
                @endforeach
            </tbody>
        </table>
        <div class="justify-content-md-center p-5">
            <div class="col-md-auto">
                {{ $articles->links()}}
            </div>
        </div>
    </div>
@endsection